open Bsml
open Stdlib.Base
open Tools
open NatTools
open BsmlSpec 
open Datatypes 

module Primitives : PRIMITIVES with type 'a par = 'a Bsml.par  =
struct

  type processor = nat

  type 'a par = 'a Bsml.par

  let bsp_p = nat_of_int (Bsml.bsp_p)

  let get v i = failwith "should not be called"

  let mkpar f = Bsml.mkpar (fun i -> f (nat_of_int i))

  let apply = Bsml.apply

  let put vf =
    parfun (fun f -> compose f int_of_nat) 
      (Bsml.put(parfun (fun f -> compose f nat_of_int)vf))

  let proj v = compose (Bsml.proj v) int_of_nat

end
